local GH = GarrisonHelper
-- Frame and Events
local GarrisonHelper_Events = CreateFrame("Frame");
local events = {};


function GH:isWorkOrdersEnabled()
	if type(GH.db.profile.workorderssupport)==nil then GH.db.profile.workorderssupport=false end -- default is false!
	return GH.db.profile.workorderssupport
end

function events.SHIPMENT_CRAFTER_INFO(uiTab, currWorkOrders, maxWorkOrders, plotID)
	local buildingID  = C_Garrison.GetOwnedBuildingInfo(plotID)
	if buildingID then
		if GH.db.profile.workordersbuildingenabled and GH.db.profile.workordersbuildingenabled[GH:buildingHash(buildingID)] and GarrisonCapacitiveDisplayFrame then
			if GH:buildingHash(buildingID)==111 then --trading post
				for i = 1, C_Garrison.GetNumShipmentReagents() do
					local name, texture, quality, needed, quantity, itemID = C_Garrison.GetShipmentReagentInfo(i);
					GH.db.profile.tradingpostworkorder = {}
					GH.db.profile.tradingpostworkorder.itemID = itemID
					GH.db.profile.tradingpostworkorder.itemName  = name
					GH.db.profile.tradingpostworkorder.validuntil = time()+GetQuestResetTime()
					if not GH.db.profile.workorderstradegood[itemID] then
						-- trade good not selected in /gh
						return
					end
				end
			end
			local b = GarrisonCapacitiveDisplayFrame.CreateAllWorkOrdersButton
			if b and b:IsVisible() and b:IsEnabled() and currWorkOrders < maxWorkOrders then
				b:Click()
			end
		end
	end
end

-- register event listener
GarrisonHelper_Events:SetScript("OnEvent", function(self, event, ...) events[event](...); end);
for event, func in pairs(events) do GarrisonHelper_Events:RegisterEvent(event); end

function GH:WorkOrdersBuilding(buildingID)
	local res = ""
	local buildingName = select(2,C_Garrison.GetBuildingInfo(buildingID))
	res = buildingName;
	return res
end

function GH:WorkOrdersBuildingTooltip(buildingID)
	local res = ""
	local description = select(5,C_Garrison.GetBuildingInfo(buildingID))
	res = description;
	return res
end

function GH:WorkOrdersTradegood(itemID)
	local res = ""
	local itemName = GetItemInfo(itemID)
	res = itemName;
	return res
end

function GH:WorkOrdersTradegoodTooltip(itemID)
	local res = ""
	local itemTexture = select(10,GetItemInfo(itemID))
	res = "\124T" .. itemTexture  ..":24\124t";
	return res
end


--[[
	Needed, because if cache is empty, this information have to be retrieved from server.
]]
function GH:PreLoadWorkorderItemInfos()
	--for i=1,#millingPriority do
	--	GetItemInfo(millingPriority[i])
	--end
end
GH:PreLoadWorkorderItemInfos() -- TODO move this to an event like addon loaded